local mtool = {}

function mtool.reset_buffer(mesh_url)
	-- get origin vertices
	local res = go.get(mesh_url, "vertices")
	local old_buffer = resource.get_buffer(res)
	local original_position = buffer.get_stream(old_buffer, "position")
	local original_normal = buffer.get_stream(old_buffer, "normal")
	local original_color0 = buffer.get_stream(old_buffer, "color0")
	local original_texcoord0 = buffer.get_stream(old_buffer, "texcoord0")
	local num_vertices =  #original_position / 3
	
	-- create a new buffer
	local new_buffer = buffer.create(num_vertices, {
		{ name = hash("position"), type=buffer.VALUE_TYPE_FLOAT32, count = 3 },
		{ name = hash("normal"), type=buffer.VALUE_TYPE_FLOAT32, count = 3 },
		{ name = hash("texcoord0"), type=buffer.VALUE_TYPE_FLOAT32, count = 2 },
		{ name = hash("color0"), type=buffer.VALUE_TYPE_FLOAT32, count = 4 }
	})

	-- get the stream
	local stream_position = buffer.get_stream(new_buffer, "position")
	local stream_normal = buffer.get_stream(new_buffer, "normal")
	local stream_texcoord0 = buffer.get_stream(new_buffer, "texcoord0")
	local stream_color0 = buffer.get_stream(new_buffer, "color0")

	-- copy original values to stream
	for i = 1, #original_position do 	stream_position[i] = original_position[i] end
	for i = 1, #original_normal do 		stream_normal[i] = original_normal[i] end
	for i = 1, #original_color0 do 		stream_color0[i] = original_color0[i] end
	for i = 1, #original_texcoord0 do 	stream_texcoord0[i] = original_texcoord0[i] end

	-- set new buffer
	resource.set_buffer(res, new_buffer)
end

return mtool